/*-
 * Copyright (c) 2019 UPLEX Nils Goroll Systemoptimierung
 * All rights reserved
 *
 * Author: Geoffrey Simmons <geoffrey.simmons@uplex.de>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <stdint.h>
#include <stddef.h>
#include <string.h>

/*
 * XXX mockup for testing
 * These are the keys in the two examples in chs 3.1 & 3.2 of RFC 8188.
 */
static struct key {
	char *id;
	const uint8_t idlen;
	uint8_t key[16];
} key[] = {
	{
		"",
		0,
		{
			0xca, 0xa7, 0x65, 0x67, 0xeb, 0x58, 0x7a, 0x67,
			0xe8, 0x81, 0x29, 0xaf, 0xed, 0x6b, 0x39, 0x3d,
		},
	},
	{
		"a1",
		2,
		{
			0x04, 0xed, 0xd9, 0x54, 0xfc, 0x54, 0x96, 0x72,
			0xce, 0x45, 0xb5, 0x46, 0x32, 0x96, 0xd3, 0xd5,
		},
	},
	{
		NULL,
		0,
		{ 0 }
	},
};

static inline uint8_t *
get_key(uint8_t *id, uint8_t idlen)
{
	for (int i = 0; key[i].key != NULL; i++)
		if (idlen != key[i].idlen)
			continue;
		else if (idlen == 0 && key[i].idlen == 0)
			return key[i].key;
		else if (memcmp(id, key[i].id, idlen) == 0)
			return key[i].key;
	return (NULL);
}
